
#include <cstdio>
#include <algorithm>
using namespace std;


int N, M;
int traffic[301][301], table_road[301][301], list_set[301],  result[300];
int num_center, table_value[301][301];

struct roads{
	int a,b,l,n;
	bool operator < (roads const &v) const {return (this->l < v.l);}
} ir[45000];

struct values{
	int n;
	struct columns{
		int b, val;
		bool operator < (columns const &w) const {return (this->val < w.val);}
	} col[302];
} val[302];

struct centers{
	int town, n_sum, sum, non; 
} cen[301];

void compression(int i){   
	int j;
	for(j=1; j<val[i].n; j++){   
		val[i].col[j].b = val[i].col[j+1].b;
		val[i].col[j].val = val[i].col[j+1].val;
	}
	val[i].n--;
}

void SetTableRoad(){
	for(int i=1; i<=M; i++){
		table_road[ir[i].a][ir[i].b] = table_road[ir[i].b][ir[i].a] = i;
	}
}

void SetValue(){
	int i, j, n;
	for(i=1; i<=N; i++){
		n = 0;
		for(j=1; j<=N; j++){
			if(i == j) {val[i].col[j].val = 9999; continue;}
			if(table_road[i][j] == 0) { val[i].col[j].val = 9999; continue;}
			val[i].col[j].val = ir[table_road[i][j]].l; val[i].col[j].b = j; n++;
		}
		val[i].n = n;
	}
}

void sort2(){
	for(int i=1; i<=N; i++){
		sort(&val[i].col[1], &val[i].col[N+1]);
	}
}

void SolveOneTraff(){
	int i, temp, R = 2;
	double min_average, ta;
	list_set[ir[1].a] = 1; list_set[ir[1].b] = 1;
	cen[1].town = ir[1].a; cen[2].town = ir[1].b;
	cen[1].n_sum = cen[2].n_sum = 2; 
	cen[1].sum = cen[2].sum = ir[1].l; num_center = 2; 
	result[1] = ir[1].n; 
	while(1){ 
		min_average = 100000.0;
		for(i=1; i<=num_center; i++){   
			if(cen[i].non) continue;
			while(1){
				if(val[cen[i].town].n == 0) {cen[i].non++; break;}
				if(list_set[val[cen[i].town].col[1].b] == 1){
					if(val[cen[i].town].n == 1){cen[i].non++; break;}
					compression(cen[i].town); continue;
				}
				ta = ((double)cen[i].sum + (double)val[cen[i].town].col[1].val)/((double)cen[i].n_sum); 
				if(ta < min_average){min_average = ta; temp = i;} break;
			}
		}
		result[R] = ir[table_road[cen[temp].town][val[cen[temp].town].col[1].b]].n;
		R++; if(R == N) break;
		num_center++; cen[num_center].town = val[cen[temp].town].col[1].b;
		cen[num_center].sum = val[cen[temp].town].col[1].val; cen[num_center].n_sum = 2;
		list_set[val[cen[temp].town].col[1].b] = 1;
		cen[temp].sum += val[cen[temp].town].col[1].val; cen[temp].n_sum++;
		compression(cen[temp].town);	
	}
}

void Input(){
	FILE *In = fopen("graph.in", "r");
	fscanf(In,"%i %i\n", &N, &M);
	for(int i=1; i<=M; i++){
		fscanf(In, "%i %i %i\n", &ir[i].a, &ir[i].b, &ir[i].l); ir[i].n = i;
	}
	for(int i=1; i<=N; i++){
		for(int j=1; j<=N; j++){
			fscanf(In, "%i ", &traffic[i][j]);
		}
	}
}

void Output(){
	FILE *Out = fopen("graph.out", "w");
	for(int i=1; i<N; i++){
		fprintf(Out, "%i\n", result[i]);
	}
}



int main(){
	Input();
	sort(&ir[1], &ir[M+1]);
	SetTableRoad();
	SetValue();
	sort2();
	SolveOneTraff();
	Output();

	return 0;
}